# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from squirrel_object_perception_msgs/DynamicObject.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import geometry_msgs.msg
import std_msgs.msg

class DynamicObject(genpy.Message):
  _md5sum = "963192e0991b4f269ced46cc5ad80674"
  _type = "squirrel_object_perception_msgs/DynamicObject"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """# dynamic object description
# author: Edith Langer, langer@acin.tuwien.ac.at

geometry_msgs/Pose pose
std_msgs/Float64 x_dim
std_msgs/Float64 y_dim
std_msgs/Float64 z_dim

================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of postion and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

================================================================================
MSG: std_msgs/Float64
float64 data"""
  __slots__ = ['pose','x_dim','y_dim','z_dim']
  _slot_types = ['geometry_msgs/Pose','std_msgs/Float64','std_msgs/Float64','std_msgs/Float64']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       pose,x_dim,y_dim,z_dim

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(DynamicObject, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.pose is None:
        self.pose = geometry_msgs.msg.Pose()
      if self.x_dim is None:
        self.x_dim = std_msgs.msg.Float64()
      if self.y_dim is None:
        self.y_dim = std_msgs.msg.Float64()
      if self.z_dim is None:
        self.z_dim = std_msgs.msg.Float64()
    else:
      self.pose = geometry_msgs.msg.Pose()
      self.x_dim = std_msgs.msg.Float64()
      self.y_dim = std_msgs.msg.Float64()
      self.z_dim = std_msgs.msg.Float64()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_struct_10d.pack(_x.pose.position.x, _x.pose.position.y, _x.pose.position.z, _x.pose.orientation.x, _x.pose.orientation.y, _x.pose.orientation.z, _x.pose.orientation.w, _x.x_dim.data, _x.y_dim.data, _x.z_dim.data))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      if self.pose is None:
        self.pose = geometry_msgs.msg.Pose()
      if self.x_dim is None:
        self.x_dim = std_msgs.msg.Float64()
      if self.y_dim is None:
        self.y_dim = std_msgs.msg.Float64()
      if self.z_dim is None:
        self.z_dim = std_msgs.msg.Float64()
      end = 0
      _x = self
      start = end
      end += 80
      (_x.pose.position.x, _x.pose.position.y, _x.pose.position.z, _x.pose.orientation.x, _x.pose.orientation.y, _x.pose.orientation.z, _x.pose.orientation.w, _x.x_dim.data, _x.y_dim.data, _x.z_dim.data,) = _struct_10d.unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_struct_10d.pack(_x.pose.position.x, _x.pose.position.y, _x.pose.position.z, _x.pose.orientation.x, _x.pose.orientation.y, _x.pose.orientation.z, _x.pose.orientation.w, _x.x_dim.data, _x.y_dim.data, _x.z_dim.data))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      if self.pose is None:
        self.pose = geometry_msgs.msg.Pose()
      if self.x_dim is None:
        self.x_dim = std_msgs.msg.Float64()
      if self.y_dim is None:
        self.y_dim = std_msgs.msg.Float64()
      if self.z_dim is None:
        self.z_dim = std_msgs.msg.Float64()
      end = 0
      _x = self
      start = end
      end += 80
      (_x.pose.position.x, _x.pose.position.y, _x.pose.position.z, _x.pose.orientation.x, _x.pose.orientation.y, _x.pose.orientation.z, _x.pose.orientation.w, _x.x_dim.data, _x.y_dim.data, _x.z_dim.data,) = _struct_10d.unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
_struct_10d = struct.Struct("<10d")
